=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2009-06-19 09:06:56 +0000
+++ bzrlib/builtins.py	2009-06-22 09:01:51 +0000
@@ -1044,7 +1044,8 @@
         if directory is None:
             directory = '.'
         # Get the source branch
-        tree, br_from = bzrdir.BzrDir.open_tree_or_branch(directory)
+        (tree, br_from,
+         _unused) = bzrdir.BzrDir.open_containing_tree_or_branch(directory)
         if strict is None:
             strict = br_from.get_config().get_user_option('push_strict')
             if strict is not None:

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2009-06-17 08:08:36 +0000
+++ bzrlib/tests/blackbox/test_push.py	2009-06-22 08:14:24 +0000
@@ -475,6 +475,15 @@
         # subsequent log is accurate
         self.assertNotContainsRe(out, 'rev1')
 
+    def test_push_from_subdir(self):
+        t = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/dir/', 'tree/dir/file'])
+        t.add('dir', 'dir/file')
+        t.commit('r1')
+        out, err = self.run_bzr('push ../../pushloc', working_dir='tree/dir')
+        self.assertEqual('', out)
+        self.assertEqual('Created new branch.\n', err)
+
 
 class RedirectingMemoryTransport(memory.MemoryTransport):
 

